event_planer/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path("admin/", admin.site.urls),
    path('events/', include('events.urls')),
]
# Include AAI
urlpatterns += [
    path("helmholtz-aai/", include("django_helmholtz_aai.urls")),
 ]

events/urls.py
from django.urls import path
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.contrib.auth.views import LoginView, LogoutView
from . import views

urlpatterns = [
    path('', views.event_list, name='event_list'),
    path('login/', LoginView.as_view(), name='login'),
    path('logout/', LogoutView.as_view(), name='logout'),
    path('new/', views.event_new, name='event_new'),
    path('event/new/', views.event_new, name='event_new'),
    path('event/<int:event_id>/delete/', views.delete_event, name='delete_event'),
    path('event/<int:event_id>/edit/', views.edit_event, name='edit_event'),
    path('event/<int:event_id>/', views.get_event_details, name='get_event_details'),
]

urlpatterns += staticfiles_urlpatterns()

events/models.py
from django.db import models
from datetime import datetime
from django.db.models.signals import post_save
from django.dispatch import receiver
import requests

class Label(models.Model):
    name = models.CharField(max_length=50)

    def __str__(self):
        return self.name
    
class Event(models.Model):
    LOCATION_CHOICES = (
        ('Large Semniar Room', 'Large Semniar Room'),
        ('Small Seminar Room', 'Small Seminar Room'),
        ('Online', 'Online'),
        ('Other', 'Other'),
    )

    LABEL_CHOICES = [
        ('PhD Seminar', 'PhD Seminar'),
        ('IFU Colloquium', 'IFU Colloquium'),
        ('Public Event', 'Public Event'),
        ('Internal Event', 'Internal Event'),

        # Add more choices as needed
    ]
        
    title = models.CharField(max_length=300)
    start_date = models.DateField(default='2024-01-01')
    end_date = models.DateField(default='2024-01-01')
    start_time = models.TimeField(default='00:00:00')
    end_time = models.TimeField(default='00:00:00')
    location = models.CharField(max_length=200, choices=LOCATION_CHOICES)
    presenter = models.CharField(max_length=200)
    contact = models.EmailField()
    label = models.CharField(max_length=200, choices=LABEL_CHOICES, default='')
    ifu_contact = models.CharField(max_length=100, default='Enter contact at IFU')
    abstract = models.TextField(max_length=1000, default='Enter a short abstract')

    def __str__(self):
        return self.title


# Define a signal handler function to create GitLab issue
@receiver(post_save, sender=Event)
def create_gitlab_issue(sender, instance, created, **kwargs):
    if created:  # Only execute when a new event is created
        # GitLab API endpoint for creating an issue
        gitlab_api_url = 'https://codebase.helmholtz.cloud/api/v4/projects/11741/issues'

        # Personal Access Token for GitLab API authentication
        gitlab_token = 'glpat-z7F_PTKhRXhcUP6PHHx1'

        tasks = [
            "Reserve Room",
            "Write Invitation Mail",
            "Write Reminder",
        # Add more tasks as needed
        ]  
        # Issue details
        issue_data = {
            'title': f'New Event: {instance.title}',
            'description': '',
            'labels': ['event']
        }

        # Add tasks to the issue description
        for index, task in enumerate(tasks, start=1):
            issue_data['description'] += f'\n{index}. [ ] {task}'  # Format each t

        # HTTP POST request to create the issue
        headers = {'PRIVATE-TOKEN': gitlab_token}
        response = requests.post(gitlab_api_url, json=issue_data, headers=headers)

        if response.status_code == 201:
            print('GitLab issue created successfully!')
        else:
            print(f'Failed to create GitLab issue. Status code: {response.status_code}, Error: {response.text}')

events/forms.py
from django import forms
from .models import Event
from bootstrap_datepicker_plus.widgets import DatePickerInput, TimePickerInput, DateTimePickerInput, MonthPickerInput, YearPickerInput

class EventForm(forms.ModelForm):
    class Meta:
        model = Event
        fields = ['title', 'start_date', 'end_date', "start_time", "end_time", 'location', 'presenter', 'contact', 'label', 'ifu_contact', 'abstract']
        widgets = {
            "start_date": DatePickerInput(),
            "end_date": DatePickerInput(range_from="start_date"),
            "start_time": TimePickerInput(),
            "end_time": TimePickerInput(range_from="start_time"),
        }

events/views.py
from django.shortcuts import render, redirect, get_object_or_404
from .models import Event
from .forms import EventForm
from datetime import datetime
from django.http import JsonResponse

def event_list(request):
    # Get current date
    current_date = datetime.now().date()

    # Query upcoming events
    upcoming_events = Event.objects.filter(start_date__gte=current_date).order_by('start_date')[:2]
 
    # Query all events
    events = Event.objects.order_by('-start_date').all()

    context = {
        'upcoming_events': upcoming_events,
        'events': events,
        'current_date': current_date
    }

    return render(request, 'events/event_list.html', context)

def event_new(request):
    if request.method == "POST":
        form = EventForm(request.POST)
        if form.is_valid():
            event = form.save(commit=False)
            event.save()
            return redirect('event_list')
    else:
        form = EventForm()
    return render(request, 'events/event_new.html', {'form': form})
###
#def edit_event(request, event_id):
#    event = get_object_or_404(Event, pk=event_id)
#    if request.method == 'POST':
#        form = EventForm(request.POST, instance=event)
#        if form.is_valid():
#            form.save()
#            return redirect('event_list')  # Redirect to event list page after editing
#    else:
#        form = EventForm(instance=event)
#    return render(request, 'events/event_edit.html', {'form': form})
###

def edit_event(request, event_id):
    event = get_object_or_404(Event, pk=event_id)
    if request.method == 'POST':
        form = EventForm(request.POST, instance=event)
        if form.is_valid():
            form.save()
            return redirect('event_list')  # Redirect to event list page after editing
    else:
        form = EventForm(instance=event)
    return render(request, 'events/event_edit.html', {'form': form, 'event': event})

def delete_event(request, event_id):
    event = get_object_or_404(Event, pk=event_id)
    if request.method == 'POST':
        event.delete()
        return redirect('event_list')  # Redirect to event list page after deletion
    return redirect('event_list')  # Redirect if accessed through a GET request (optional)

def get_event_details(request, event_id):
    try:
        #event = Event.objects.get(id=event_id)
        event = get_object_or_404(Event, pk=event_id)
        # Assuming Event model has fields like abstract
        event_details = {
            'title': event.title,
            'presenter': event.presenter,
            'abstract': event.abstract,
            'contact': event.contact,
            'ifu_contact': event.ifu_contact,

            # Add more fields as needed
        }
        return JsonResponse(event_details)
    except Event.DoesNotExist:
        return JsonResponse({'error': 'Event not found'}, status=404)

events/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
   
<head>
    <meta charset="UTF-8">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-...NNiOxAyelOBG0R8hYAwOQQ==" crossorigin="anonymous">
    <title>{% block title %}IFU Event Scheduler{% endblock %}</title>
    <!--<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <!-- Add Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-...5bEYNIVCA8anuOQbzvp8yH/2K5Tz5GKt5lVzfwGsWf1Jq4P0qPBiNrU2ufe5hc=" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="{% static 'styles.css' %}">
    {{ form.media }}
</head>
<body>

    <header class="header">
        <div class="logo-container">
            <img src="{% static 'kitlogo.png' %}" alt="Logo 1" >
            <img src="{% static 'campusalpin.jpg' %}" alt="Logo 1" >
        </div>
        <h1 class="title">IFU Event Scheduler</h1>
        {% if user.is_authenticated %}
            <a href="{% url 'logout' %}" class="btn btn-primary btn-block">Logout</a>
        {% else %}
            <a href="{% url 'login' %}" class="btn btn-primary btn-block">Login</a>
        {% endif %}

    </header>
    <hr>
    <main>
        {% block content %}
        {% endblock %}
    </main>


</body>
</html>

events/templates/events/event_edit.html
{% extends 'base.html' %}

{% block content %}
<div class="container">
    <div class="form-container">
        <h2>Edit Event</h2>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit" class="btn btn-primary btn-block">Save Changes</button>
            <a href="{% url 'event_list' %}" class="btn btn-secondary">Cancel</a>
        </form>
        <form id="delete-event-form-{{ event.id }}" action="{% url 'delete_event' event.id %}" method="post">
            {% csrf_token %}
            <button type="button" class="btn btn-danger btn-block" onclick="confirmDelete('{{ event.id }}')">Delete Event</button>
        </form>
    </div>
</div>

<script>
    function confirmDelete(eventId) {
        if (confirm("Are you sure you want to delete this event?")) {
            document.getElementById("delete-event-form-" + eventId).submit();
        }
    }
</script>

{% endblock %}

events/templates/events/event_list.html
<!-- event_list.html -->
{% extends 'base.html' %}

{% block content %}
<!-- Add jQuery (before Bootstrap JS) -->



<!-- Event List -->
{% if user.is_authenticated %}
    <div class="center-button-container">
        <a href="{% url 'event_new' %}" class="btn btn-primary btn-block">Create New Event</a>
    </div>
{% endif %}

<div class="center-button-container btn-block" aria-label="Event Filters">
    <button type="button" class="btn btn-primary equal-width" data-filter="All">All</button>
    <button type="button" class="btn btn-primary equal-width" style="background-color: #decbe4" data-filter="PhD Seminar">PhD Seminar</button>
    <button type="button" class="btn btn-primary equal-width" style="background-color: #b3cde3" data-filter="IFU Colloquium">IFU Colloquium</button>
    <button type="button" class="btn btn-primary equal-width" style="background-color: #ccebc5" data-filter="Public Event">Public Event</button>
    <button type="button" class="btn btn-primary equal-width" style="background-color: #fbb4ae" data-filter="Internal Event">Internal Event</button>
</div>

<div id="eventContainer" class="container">
    <h3>Upcoming Events</h3>
    <br>
    {% for event in upcoming_events %}
        <div class="row event" data-label="{{ event.label }}">
            <div class="col">
                <div class="card mb-4" style="background-color: 
                    {% if event.label == 'PhD Seminar' %} #decbe4;
                    {% elif event.label == 'IFU Colloquium' %} #b3cde3;
                    {% elif event.label == 'Public Event' %} #ccebc5;
                    {% elif event.label == 'Internal Event' %} #fbb4ae;
                    {% endif %}">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-8">
                                <h5 class="card-title">{{ event.title }}</h5>
                                <p class="card-text">{{ event.presenter }}</p>
                                {% if event.start_date == event.end_date  %}
                                    <p class="card-text">{{ event.start_date }}, {{ event.start_time|time:"H:i" }} - {{ event.end_time|time:"H:i" }} </p>
                                {% else %}
                                    <p class="card-text">{{ event.start_date }}:{{ event.start_time|time:"H:i" }} - {{ event.end_date }}:{{ event.end_time|time:"H:i" }} </p>
                                {% endif %}
                                <p class="card-text">{{ event.location }}</p>
                            </div>
                            <div class="col-md-4">
                                <div class="d-grid gap-2">
                                    <button type="button" class="btn btn-primary btn-block equal-width" onclick="showEventModal('{{ event.id }}')">
                                        Details
                                    </button>
                                    {% if user.is_authenticated %}
                                        <a href="{% url 'edit_event' event.id %}" class="btn btn-secondary btn-block equal-width">Edit</a>
                                    {% endif %}
                                </div>
                            </div>
                        </div>
                    </div>
                </div> 
            </div>
        </div>
            
    {% empty %}
        <li>No upcoming events</li>
    {% endfor %}

    <hr>


    {% if events %}    
        {% regroup events by start_date|date:"F Y" as events_by_month %}
        {% for month_events in events_by_month %}
            <div class="month-block">
                <h3>{{ month_events.grouper }}</h3>
                <br>
                {% for event in month_events.list %}
                    <div class="row event" data-label="{{ event.label }}">
                        <div class="col">
                            <div class="card mb-4" style="background-color: 
                            {% if event.label == 'PhD Seminar' %} #decbe4;
                            {% elif event.label == 'IFU Colloquium' %} #b3cde3;
                            {% elif event.label == 'Public Event' %} #ccebc5;
                            {% elif event.label == 'Internal Event' %} #fbb4ae;
                            {% endif %}">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-md-8">
                                        <h5 class="card-title">{{ event.title }}</h5>
                                        <p class="card-text">{{ event.presenter }}</p>
                                        {% if event.start_date == event.end_date  %}
                                            <p class="card-text">{{ event.start_date }}, {{ event.start_time|time:"H:i" }} - {{ event.end_time|time:"H:i" }} </p>
                                        {% else %}
                                            <p class="card-text">{{ event.start_date }}:{{ event.start_time|time:"H:i" }} - {{ event.end_date }}:{{ event.end_time|time:"H:i" }} </p>
                                        {% endif %}
                                        <p class="card-text">{{ event.location }}</p>
                                    </div>
                                    <div class="col-md-4">
                                        <div class="d-grid gap-2">
                                            <!--
                                            <button type="button" class="btn btn-primary btn-block equal-width" data-bs-toggle="modal" data-bs-target="#eventModal{{ event.id }}">
                                                Details
                                            </button>
                                            -->
                                            
                                            <button type="button" class="btn btn-primary btn-block equal-width" onclick="showEventModal('{{ event.id }}')">
                                                Details
                                            </button>
                                            <!--
                                            <button type="button" class="btn btn-primary btn-block equal-width" id="openModalBtn"">
                                                Details
                                            </button>
                                            -->
                                            {% if user.is_authenticated %}
                                                <a href="{% url 'edit_event' event.id %}" class="btn btn-secondary btn-block equal-width">Edit</a>
                                            {% endif %}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div> 
                    </div>
                {% endfor %}
                <br>
            </div>
        {% endfor %}
        </div>

    {% else %}
        <p>No events available.</p>
    {% endif %}
</div>

<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" aria-labelledby="Detail_modal" aria-hidden="false">
    <div class="modal-dialog modal-dialog-centered modal-lg">
        <div class="modal-content">
            <div class="modal-header" style="max-width: 80%; margin: auto;">
                <h5 class="modal-title" id="Detail_modal"></h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body" id="modalBody" style="max-width: 80%; margin: auto;">
                <p>SO EIN EIMER</p>
            </div>
            <div class="modal-footer" style="max-width: 80%; margin: auto;">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>



<script>
    function showEventModal(eventID) {
      // Fetch JSON data
      fetch(`/events/event/${eventID}/`)
        .then(response => response.json())
        .then(eventDetails => {
          // Populate modal with JSON data
          console.log(eventDetails.title)
          document.getElementById('Detail_modal').textContent = eventDetails.title;
          document.getElementById('modalBody').innerHTML = `
            <p>Description: ${eventDetails.abstract}</p>
            <p>Contact: ${eventDetails.contact}</p>
            <p>IFU Contact: ${eventDetails.ifu_contact}</p>
            <!-- Add more fields as needed -->
          `;
        
          console.log(eventDetails.title)
          // Show the modal
          var myModal = new bootstrap.Modal(document.getElementById('myModal'));
          myModal.title='SACK'
          myModal.show();
          console.log(myModal)
        })
        
        .catch(error => {
          console.error('Error fetching JSON:', error);
        });
    };
  </script>



{% endblock %}

events/templates/events/event_new.html
<!-- event_list.html -->
{% extends 'base.html' %}

{% block content %}
<div class="container">
  <div class="form-container">
    <h2>New Event</h2>
    <form method="post">
      {% csrf_token %}
      <div class="form-row">
        <div class="form-group col-md-6 mb-3">
          <label for="id_title">Title:</label>
          {{ form.title }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_date">Start Date:</label>
          {{ form.start_date }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_start_time">Start Time:</label>
          {{ form.start_time }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_end_time">End Date:</label>
          {{ form.end_date }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_end_time">End Time:</label>
          {{ form.end_time }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_location">Location:</label>
          {{ form.location }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_presenter">Presenter:</label>
          {{ form.presenter }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_contact">Contact:</label>
          {{ form.contact }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_label">Label:</label>
          {{ form.label }}
      </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_ifu_contact">IFU Contact:</label>
          {{ form.ifu_contact }}
        </div>
        <div class="form-group col-md-12 mb-3">
          <label for="id_abstract">Abstract:</label>
          {{ form.abstract }}
        </div>
      </div>
      <div class="button-container row">
        <div class="col-md-4 mb-3">
          <button type="submit" class="btn btn-primary btn-lg btn-block">Save</button>
        </div>
        <div class="col-md-4 mb-3">
          <a href="{% url 'event_list' %}" class="btn btn-secondary btn-lg btn-block">Cancel</a>
        </div>
        <div class="col-md-4 mb-3">
          <a href="https://booked.imk-ifu.kit.edu/Web/?" class="btn btn-secondary btn-lg btn-block">IFU Reservation System</a>
        </div>
      </div>
    </form>
  </div>
</div>
{% endblock %}